Bug 1459861 - Disable the ability to deploy with custom cluster names
Disable the ability to deploy with custom cluster names
Status: NEW
Product: Red Hat Ceph Storage
Classification: Red Hat
Component: Ceph-Ansible (Show other bugs)
3.0
Unspecified Unspecified
medium Severity medium
: rc
: 3.1
Assigned To: Guillaume Abrioux
ceph-qe-bugs
: Reopened
Depends On:
Blocks: 1410195
  Show dependency treegraph
 
Reported: 2017-06-08 07:58 EDT by Alfredo Deza
Modified: 2017-11-08 08:33 EST (History)
10 users (show)

See Also:
Fixed In Version:
Doc Type: Deprecated Functionality
Doc Text:
Custom cluster names are no longer supported
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-07-06 11:14:55 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Alfredo Deza 2017-06-08 07:58:25 EDT
Description of problem: Ceph will stop supporting custom cluster names, so deployment tools must be first in disallowing that customization.



Additional info:
Discussed in the June 6th CDM, this was mostly a novelty to allow multiple clusters in a single node which doesn't even work today as the systemd scripts read the variable from /etc/sysconfig/
Comment 3 seb 2017-06-13 05:48:39 EDT
How do we maintain backward compatibility for this?
Comment 4 Alfredo Deza 2017-06-13 08:03:11 EDT
The deployment tools will not maintain backward compatibility explicitly in this case.

Ceph itself can still have custom cluster names, and the first step to prevent users from having custom cluster names is to have deployment tools stop exposing this feature.

Everything on the Ceph side will still be supported.
Comment 5 seb 2017-06-13 08:53:18 EDT
Alright, thanks.

However, with containers, I think there is a real use case for that and we are not dependant of systemd and how it reads Ceph's config file since we have our own.

Can this decision be revisited?
Comment 6 Gregory Meno 2017-06-13 13:27:42 EDT
I think that we should offer to upgrade clusters that aren't named ceph.
Would we rename them? What do you think acceptable behavior is here?
Comment 7 Alfredo Deza 2017-06-14 08:13:38 EDT
Discussed this with Sebastien with more detail. Ceph is not going to stop working with custom cluster names, just that the deployment tools will stop allowing using ``--cluster`` to configure clusters.

I believe that the upgrade path means moving /etc/ceph/<custom cluster name>.conf to /etc/ceph/ceph.conf which sounds reasonable.

In that case I think ceph-ansible should have a separate step to do this change, and prevent playbook execution if custom cluster names are used.
Comment 8 seb 2017-06-14 11:21:15 EDT
Renaming a cluster that isn't named Ceph would break customer's scripts. Also, we would not only have to change the ceph.conf but also rename all the key in /etc/ceph and /var/lib/ceph/bootstrap-*/

The more I think about it, the more I'm worried about breaking too many things.

I think we should just remove the variable 'cluster' from group_vars to hide it. So if someone has this option enabled (for a cluster not named Ceph) then nothing would break. In the code, we will just declare this variable with a default to 'ceph'. 

With that, we don't break upgrades or existing no-named-ceph clusters and also we don't encourage people using a different cluster name since we 'hide' the functionality. I suspect a warning might be valuable too if we detect a cluster name not named Ceph...
Comment 10 seb 2017-07-06 11:14:55 EDT
As discussed with Alfredo, we want to keep the multi-cluster support around for several use-cases:


- Ceph cluster on demand with containers
- Distributed compute nodes
- rbd-mirror integration as part of OSPd
- Disaster scenario with OpenStack Cinder in OSPd

Also, we haven't had any major issues with this support so it'll be a bad idea to drop something so stable.
Thanks.
Comment 11 Alfredo Deza 2017-11-08 08:15:45 EST
Re-opening as per discussion on ceph-devel http://lists.ceph.com/pipermail/ceph-users-ceph.com/2017-November/022244.html

This is really not only a problem of robustness in ceph-ansible, it is pervasive everywhere else. 

As of *today* ceph-disk has issues with custom cluster names, and ceph-volume just hit one issue with it that has just got fixed.

The following ceph-disk PR got closed because of the new discussion in ceph-devel 

https://github.com/ceph/ceph/pull/18638

That means that ceph-ansible will hit that problem if it continues to allow custom cluster name deployments.

Note You need to log in before you can comment on or make changes to this bug.